        .486
        .model flat,stdcall
        option casemap:none             ; Case sensitive
;
        include \masm32\include\windows.inc
        include \masm32\include\user32.inc
        include \masm32\include\kernel32.inc
        include \masm32\include\gdi32.inc
        include \masm32\include\comctl32.inc
;
        includelib  \masm32\lib\user32.lib
        includelib  \masm32\lib\kernel32.lib
        includelib  \masm32\lib\gdi32.lib
        includelib  \masm32\lib\comctl32.lib
;
ID_BUTTON1  equ 1000
ID_BUTTON2  equ 2000
ID_BUTTON3  equ 3000
ID_BUTTON4  equ 4000
ID_BUTTON5  equ 5000
ID_BUTTON6  equ 6000
ID_SLIDER1  equ 7000
ID_TIMER    equ 1
;
BmpAnimation        PROTO :DWORD,:DWORD,:DWORD,:DWORD
Image_Frame_Loader  PROTO :DWORD,:DWORD,:DWORD
Paint_Bmp_Frame     PROTO :DWORD,:DWORD
Paint_Ani_Window    PROTO :DWORD
;
.data
;---------------------------------------
MaxFrames   dd  0
hBmpArray   dd  0
hBmpIndex   dd  0
FrameSpeed  dd  60
ShowAniFlag dd  0
Xsize       dd  0
Ysize       dd  0
Xplace      dd  0
Yplace      dd  0
dlgname     db  "Animation", 0
;
;
.data?
;---------------------------------------
hInstance   dd  ?
hBmp0       dd  ? 
hBmp1       dd  20 dup (?)
hBmp2       dd  20 dup (?)
hBmp3       dd  20 dup (?)
hBmp4       dd  20 dup (?)
hBmp5       dd  20 dup (?)
;
icex INITCOMMONCONTROLSEX <>            ; Structure for Calendar and Date Picker
;
;
.code
;---------------------------------------
Start:  invoke  GetModuleHandle, NULL
        mov     hInstance, eax
        mov     icex.dwSize, sizeof INITCOMMONCONTROLSEX
        mov     icex.dwICC, ICC_DATE_CLASSES
        invoke  InitCommonControlsEx, ADDR icex
;-----------------------------------------------------------;
; Image_Frame_Loader retrieves the bitmap frames from our   ;
; resource file.  Enter first bitmap number, number of      ;
; frames, pointer to handle array.                          ;
;-----------------------------------------------------------;
        invoke  Image_Frame_Loader, 99, 1, ADDR hBmp0   ; Get frame for blanking
        invoke  Image_Frame_Loader, 11, 5, ADDR hBmp1   ; Get frames of Gear bmps
        invoke  Image_Frame_Loader, 21, 11, ADDR hBmp2  ; Get frames of Jack bmps
        invoke  Image_Frame_Loader, 41, 8, ADDR hBmp3   ; Get frames of Hawk bmps
        invoke  Image_Frame_Loader, 51, 6, ADDR hBmp4   ; Get frames of Sonic bmps
        invoke  Image_Frame_Loader, 61, 8, ADDR hBmp5   ; Get frames of Sun bmps
;-----------------------------------------------------------;
;   Call the dialog box stored in resource file             ;
;-----------------------------------------------------------;
        invoke  DialogBoxParam, hInstance, ADDR dlgname, 0, ADDR BmpAnimation, 0
        invoke  ExitProcess, eax
;
;
BmpAnimation proc hWin:DWORD, uMsg:DWORD, aParam:DWORD, bParam:DWORD
;---------------------------------------
        LOCAL   Ps:PAINTSTRUCT
;
        .if uMsg == WM_INITDIALOG
          invoke  SendDlgItemMessage, hWin, ID_SLIDER1, TBM_SETRANGEMIN, FALSE, 10
          invoke  SendDlgItemMessage, hWin, ID_SLIDER1, TBM_SETRANGEMAX, FALSE, 110
          invoke  SendDlgItemMessage, hWin, ID_SLIDER1, TBM_SETLINESIZE, FALSE, 10
          invoke  SendDlgItemMessage, hWin, ID_SLIDER1, TBM_SETPOS, TRUE, FrameSpeed
          invoke  SetTimer, hWin, ID_TIMER, FrameSpeed, 0
          invoke  SetFocus, hWin
        .elseif uMsg == WM_COMMAND
          mov     eax, aParam
          .if eax == ID_BUTTON1
            mov ShowAniFlag,0
            invoke  Paint_Ani_Window, hWin
            mov     hBmpIndex, 0
            mov     Xsize, 135
            mov     Ysize, 150
            mov     Xplace, 265
            mov     Yplace, 55
            mov     MaxFrames, 5
            mov     eax, OFFSET hBmp1
            mov     hBmpArray, eax
            mov     ShowAniFlag, 1
          .elseif eax == ID_BUTTON2
            mov     ShowAniFlag, 0
            invoke  Paint_Ani_Window, hWin
            mov     hBmpIndex, 0
            mov     Xsize, 100
            mov     Ysize, 113
            mov     Xplace, 283
            mov     Yplace, 67
            mov     MaxFrames, 11
            mov     eax, OFFSET hBmp2
            mov     hBmpArray, eax
            mov     ShowAniFlag, 1
          .elseif eax == ID_BUTTON3
            mov     ShowAniFlag, 0
            invoke  Paint_Ani_Window, hWin
            mov     hBmpIndex, 0
            mov     Xsize, 71
            mov     Ysize, 80
            mov     Xplace, 300
            mov     Yplace, 85
            mov     MaxFrames, 8
            mov     eax, OFFSET hBmp3
            mov     hBmpArray, eax
            mov     ShowAniFlag, 1
          .elseif eax == ID_BUTTON4
            mov     ShowAniFlag, 0
            invoke  Paint_Ani_Window, hWin
            mov     hBmpIndex, 0
            mov     Xsize, 100
            mov     Ysize, 100
            mov     Xplace, 285
            mov     Yplace, 80
            mov     MaxFrames, 6
            mov     eax, OFFSET hBmp4
            mov     hBmpArray, eax
            mov     ShowAniFlag, 1
          .elseif eax == ID_BUTTON5
            mov     ShowAniFlag, 0
            invoke  Paint_Ani_Window, hWin
            mov     hBmpIndex, 0
            mov     Xsize, 100
            mov     Ysize, 100
            mov     Xplace, 285
            mov     Yplace, 80
            mov     MaxFrames, 8
            mov     eax, OFFSET hBmp5
            mov     hBmpArray, eax
            mov     ShowAniFlag, 1
          .elseif eax == ID_BUTTON6
            invoke  SendMessage, hWin, WM_CLOSE, NULL, NULL
          .endif
        .elseif uMsg == WM_PAINT
          invoke  BeginPaint, hWin, ADDR Ps
          invoke  Paint_Ani_Window, hWin
          invoke  EndPaint, hWin, ADDR Ps
        .elseif uMsg == WM_CLOSE
          invoke  KillTimer, hWin, ID_TIMER
          invoke  EndDialog, hWin, NULL
        .elseif uMsg == WM_TIMER
          .if ShowAniFlag == 1
            invoke  Paint_Bmp_Frame, hWin, hBmpArray
          .endif
        .elseif uMsg == WM_HSCROLL
          mov     eax, aParam
          and     eax, 0FFFFh
          .if eax == TB_THUMBTRACK or TB_THUMBPOSITION
            mov     eax, aParam
            shr     eax, 16
            mov     FrameSpeed, eax
            invoke  SetTimer, hWin, ID_TIMER, FrameSpeed, 0
          .elseif eax == TB_LINEUP
            invoke  SendDlgItemMessage, hWin, ID_SLIDER1, TBM_GETPOS, 0, 0
            mov     FrameSpeed, eax
            invoke  SetTimer, hWin, ID_TIMER, FrameSpeed, 0
          .elseif eax == TB_LINEDOWN
            invoke  SendDlgItemMessage, hWin, ID_SLIDER1, TBM_GETPOS, 0, 0
            mov     FrameSpeed, eax
            invoke  SetTimer, hWin, ID_TIMER, FrameSpeed, 0
          .elseif eax == TB_PAGEUP
            invoke  SendDlgItemMessage, hWin, ID_SLIDER1, TBM_GETPOS, 0, 0
            mov     FrameSpeed, eax
            invoke  SetTimer, hWin, ID_TIMER, FrameSpeed, 0
          .elseif eax == TB_PAGEDOWN
            invoke  SendDlgItemMessage, hWin, ID_SLIDER1, TBM_GETPOS, 0, 0
            mov     FrameSpeed, eax
            invoke  SetTimer, hWin, ID_TIMER, FrameSpeed, 0
          .endif
        .endif
        xor     eax, eax
        ret
;---------------------------------------
BmpAnimation endp
;
;   
Paint_Bmp_Frame proc hWin:DWORD,hBmpAddress:DWORD
;---------------------------------------
        LOCAL   hDC:DWORD
        LOCAL   memDC:DWORD
        LOCAL   hOldObj:DWORD
;
        push    esi
        invoke  GetDC, hWin
        mov     hDC, eax
        invoke  CreateCompatibleDC, hDC
        mov     memDC, eax
        mov     eax, 4
        xor     edx, edx
        mul     hBmpIndex
        mov     esi, hBmpAddress
        add     esi, eax
        mov     eax, [esi]
        invoke  SelectObject, memDC, eax
        mov     hOldObj, eax
        invoke  BitBlt, hDC, Xplace, Yplace, Xsize, Ysize, memDC, 0, 0, SRCCOPY
        invoke  SelectObject, memDC, hOldObj
        invoke  DeleteDC, memDC
        invoke  ReleaseDC, hWin, hDC
        inc     hBmpIndex
        mov     eax, MaxFrames
        .if hBmpIndex == eax
          mov     hBmpIndex, 0
        .endif
        pop     esi
        ret
;---------------------------------------
Paint_Bmp_Frame endp
;
;
Paint_Ani_Window proc hWin:DWORD
;---------------------------------------
        LOCAL   hDC:DWORD
        LOCAL   memDC:DWORD
        LOCAL   hOldObj:DWORD
;
        invoke  GetDC, hWin
        mov     hDC, eax
        invoke  CreateCompatibleDC, hDC
        mov     memDC, eax
        invoke  SelectObject, memDC, hBmp0
        mov     hOldObj, eax
        invoke  BitBlt, hDC, 230, 25, 210, 210, memDC, 0, 0, SRCCOPY
        invoke  SelectObject, memDC, hOldObj
        invoke  DeleteDC, memDC
        invoke  ReleaseDC, hWin, hDC
        ret
;---------------------------------------
Paint_Ani_Window endp
;
;
Image_Frame_Loader proc BitmapNumber:DWORD,FrameCounter:DWORD,BmpHandlePointer:DWORD
;---------------------------------------
        push    esi
        mov     hBmpIndex, 0
getnext:
        invoke  LoadImage, hInstance, BitmapNumber, IMAGE_BITMAP, 0, 0, LR_DEFAULTCOLOR
        mov     esi, BmpHandlePointer
        add     esi, hBmpIndex
        mov     [esi], eax
        add     hBmpIndex, 4
        inc     BitmapNumber
        dec     FrameCounter
        jnz     getnext
        pop     esi
        ret
;---------------------------------------
Image_Frame_Loader endp
;
;
        end     Start

